<template>
  <frame :modal="modal" dimmed>
    <headline :color="color">{{ title }}</headline>

    <div class="mx-8">
      <slot></slot>
    </div>

    <actions>
      <cancel-action @click="modal.hide()" />
      <action @click="confirm()" :color="color" primary>{{ action }}</action>
    </actions>
  </frame>
</template>

<script lang="ts">
import { isModal, ModalComponents } from "@/use/modal";

export default {
  components: { ...ModalComponents },
  mixins: [isModal()],
  emits: ["confirm"],
  props: {
    title: {
      type: String,
      default: "Confirm your action"
    },
    action: {
      type: String,
      default: "Confirm"
    },
    color: {
      type: String,
      default: "blue"
    }
  },
  setup(props, context) {
    return {
      confirm: () => {
        context.emit("confirm");
        props.modal.hide();
      }
    };
  }
};
</script>
